package com.yutou.nas_music_player.Adapters;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.request.RequestOptions;
import com.yutou.nas_music_player.Datas.MusicData;
import com.yutou.nas_music_player.Interfaces.DefaultNetworkInterface;
import com.yutou.nas_music_player.Interfaces.NetworkInterface;
import com.yutou.nas_music_player.R;
import com.yutou.nas_music_player.containers.MediaBrowserHelper;
import com.yutou.nas_music_player.containers.MusicContainer;
import com.yutou.nas_music_player.tools.AppData;
import com.yutou.nas_music_player.tools.ImageLoader;

import java.util.List;

import cc.ibooker.ztextviewlib.MarqueeTextView;
import jp.wasabeef.glide.transformations.RoundedCornersTransformation;

public class AlbumsRecyclerAdapter extends RecyclerView.Adapter<AlbumsRecyclerAdapter.AlbumHolder> {
    List<MusicData> list;
    Context context;
    MediaBrowserHelper browserHelper;
    int model;
    int fid;

    public AlbumsRecyclerAdapter(Context context, List<MusicData> list, int model) {
        this.list = list;
        this.context = context;
        this.model = model;
    }

    public void setFid(int fid) {
        this.fid = fid;
    }

    @NonNull
    @Override
    public AlbumHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new AlbumHolder(LayoutInflater.from(context).inflate(R.layout.layout_music_libs_item, parent, false));
    }

    public void onStop() {
        list.clear();
    }

    @SuppressLint("SetTextI18n")
    @Override
    public void onBindViewHolder(@NonNull AlbumHolder holder, int position) {
        MusicData data = list.get(position);
        holder.title.setText(data.getTitle());
        holder.artist.setText(data.getArtist());
        holder.icon.setImageResource(R.drawable.ic_dir);
        System.out.println("icon.getTag() = " + holder.icon.getTag()+" title = "+data.getTitle());
        if (!data.isDir()) {
            holder.message.setText(data.getBitRate() + "kbps | " + data.getSampleRate() + "hz | " + data.getEncodingType());
            holder.message.setVisibility(View.VISIBLE);
            holder.artist.setVisibility(View.VISIBLE);
            //   holder.icon.setImageBitmap(ThumbnailUtils.extractThumbnail(data.getImg(), 64,64));
            if (holder.icon.getTag() == null) {
                ImageLoader.getInstance(context).showImage(holder.icon,data.getImageUrl(),AppData.minImageWidth,AppData.minImageHigh,true);
            }
        } else {
            holder.message.setText("");
            holder.play_mask.setVisibility(View.GONE);
            holder.icon.setImageResource(R.drawable.ic_dir);
        }
        holder.top.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                MusicContainer.getInstance().addTmpList(data);
                Toast.makeText(context, "已添加到队列中", Toast.LENGTH_LONG).show();
                for (MusicData musicData : MusicContainer.getInstance().getTmpPlayList()) {
                    System.out.println("临时队列:" + musicData.getTitle());
                }
            }

        });
        holder.collection.setOnClickListener(view -> {
            MusicContainer.getLibs().removeCollection(fid, new NetworkInterface() {
                @Override
                public void httpGetData(Object data, int state) {
                    AlbumsRecyclerAdapter.this.notifyDataSetChanged();
                }

                @Override
                public void httpError(Exception e) {

                }
            }, data);
        });
        holder.layout.setOnClickListener(view -> {
            browserHelper.play(data);
            if (MusicContainer.getInstance().getNowPlayData().getMd5().equals(data.getMd5())) {
                holder.play_mask.setVisibility(View.VISIBLE);
            } else {
                holder.play_mask.setVisibility(View.GONE);
            }
            notifyDataSetChanged();
        });
        if (MusicContainer.getInstance().getNowPlayData().getMd5().equals(data.getMd5())) {
            holder.play_mask.setVisibility(View.VISIBLE);
        } else {
            holder.play_mask.setVisibility(View.GONE);
        }
    }

    @Override
    public int getItemCount() {
        return list.size();
    }

    public void setData(List<MusicData> list) {
        this.list = list;
    }

    public void setPlayListener(MediaBrowserHelper browserHelper) {
        this.browserHelper = browserHelper;
    }

    public List<MusicData> getMusicDatas() {
        return list;
    }

    public static class AlbumHolder extends RecyclerView.ViewHolder {
        MarqueeTextView title, artist, message;
        LinearLayout buttons, layout;
        ImageButton collection, top, dislike;
        ImageView icon, play_mask;

        public AlbumHolder(@NonNull View itemView) {
            super(itemView);
            title = itemView.findViewById(R.id.title);
            artist = itemView.findViewById(R.id.artist);
            message = itemView.findViewById(R.id.message);
            buttons = itemView.findViewById(R.id.buttons);
            layout = itemView.findViewById(R.id.layout);
            collection = itemView.findViewById(R.id.collection);
            top = itemView.findViewById(R.id.top);
            dislike = itemView.findViewById(R.id.dislike);
            icon = itemView.findViewById(R.id.album_image);
            play_mask = itemView.findViewById(R.id.play_mask);
        }
    }
}
