package com.yutou.nas_music_player.tools;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yutou.nas_music_player.Datas.MusicData;
import com.yutou.nas_music_player.containers.MusicContainer;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

/**
 * 最后再做，用sqlite来存储，用配置文件不太放心
 */
public class CollectionTools {
    public CollectionTools(){
    }
    public static JSONArray readConfig(){
       return JSONArray.parseArray(ConfigTools.getPreferences().getString(" collection", "[]"));
    }
    private static void saveConfig(JSONArray array){
        ConfigTools.getPreferences().edit().putString("collection",array.toJSONString()).apply();
    }
    public static List<MusicData> getCollectionTitleList(){
        JSONArray array=readConfig();
        List<MusicData> list=new ArrayList<>();
        for (Object o : array) {
            JSONObject json= (JSONObject) o;
            MusicData data=new MusicData();
            data.setTitle(json.getString("title"));
            data.setDir(true);
            list.add(data);
        }
        return list;
    }
    public static boolean isCollectionTitle(String title){
        List<MusicData> list=getCollectionTitleList();
        for (MusicData data : list) {
            if(data.getTitle().equals(title)){
                return true;
            }
        }
        return false;
    }
    public static void addCollectionTitle(String title){
        JSONArray array=readConfig();
        JSONObject json=new JSONObject();
        json.put("title",title);
        json.put("collections",new JSONArray());
        array.add(json);
        saveConfig(array);
    }
    public static void addCollection(String title,MusicData data){
        JSONArray array=readConfig();
        List<MusicData> list=getCollectionList(title);
        list.add(data);
    }
    public static List<MusicData> getCollectionList(String title){
        JSONArray array=readConfig();
        List<MusicData> list=new ArrayList<>();
        for (Object o : array) {
            JSONObject json= (JSONObject) o;
            if(json.getString("title").equals(title)) {
                JSONArray co=json.getJSONArray("collections");
                break;
            }
        }
        return list;
    }
}
