package com.yutou.nas_music_player.tools;

import android.content.Context;
import android.os.Build;

import java.io.File;
import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * 日志工具
 */
public class Log {
    public static boolean isDebug = AppData.isDebug;
    private static final boolean LogPrint = false;

    public static String getErrorLog(Exception e) {
        StringWriter writer = new StringWriter();
        PrintWriter printWriter = new PrintWriter(writer);
        e.printStackTrace(printWriter);
        File path = new File(NetworkTool.downloadPath);
        StringBuilder files = new StringBuilder();
        if (path.exists()) {
            for (File file : path.listFiles()) {
                files.append(file.getName()).append("\n");
            }
        }
        String str = "phoneType = " + Build.MODEL + "\n"
                + "SDK_Version = " + Build.VERSION.SDK_INT + "\n"
                + "files = " + files
                + "Error = \n";
        return str + writer;
    }

    private static void printOrInfo(String string) {
        if (LogPrint || isDebug) {
            System.out.println("[KUKUSDK_L]" + string);
        }
        //    LogW.i(string);
    }

    private static void printOrError(String string) {
        if (LogPrint || isDebug) {
            System.err.println("[KUKUSDK_E]" + string);
        }
        //   LogW.i(string);
        
    }

    public static void i(Object title, String text) {
        if (title instanceof String) {
            printOrInfo("[" + title + "]" + text);
        } else {
            printOrInfo("[" + title.getClass().getName() + "]" + text);
        }
    }

    public static void e(Object title, String text) {
        if (title instanceof String) {
            printOrError("[" + title + "]" + text);
        } else {
            printOrError("[" + title.getClass().getName() + "]" + text);
        }
    }

    public static void e(Object title, Exception e) {
        //   e.printStackTrace();
        StringWriter writer = new StringWriter();
        PrintWriter printWriter = new PrintWriter(writer);
        e.printStackTrace(printWriter);
        printOrError("[" + title + "]" + writer);
    }

    public static void toast(final Context context, final String string) {
        AppData.handler.post(new Runnable() {
            @Override
            public void run() {
                //  Toast.makeText(Utils.getTopActivity(), string, Toast.LENGTH_SHORT).show();
                i("Toast", string);
            }
        });
    }
}
