package com.yutou.nas_music_player.tools;


import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.yutou.nas_music_player.Interfaces.DownloadInterface;
import com.yutou.nas_music_player.Interfaces.NetworkInterface;
import com.yutou.nas_music_player.MyApplication;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.ConnectException;
import java.net.HttpURLConnection;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import static com.yutou.nas_music_player.tools.NetworkTool.NetworkAPI.HOME;
import static com.yutou.nas_music_player.tools.NetworkTool.NetworkAPI.HTTP_KEY;


public class NetworkTool {

    public static class NetworkAPI {
        public static final String HTTP_KEY = "OHreoKn2CSlDipWV6phEupAqPIX2LJFl";
        public static String HOME = "";
        public static String MUSIC_LIST = HOME + "/music/list.do";
        public static String MUSIC_Album = HOME + "/music/getAlbum.do";
        public static String MUSIC_Collection_Dir_List = HOME + "/music/favorite/dir/list.do";
        public static String MUSIC_Collection_Dir_Add = HOME + "/music/favorite/dir/add.do";
        public static String MUSIC_Collection_Dir_ReName = HOME + "/music/favorite/dir/rename.do";
        public static String MUSIC_Collection_Get = HOME + "/music/favorite/get.do";
        public static String MUSIC_Collection_Add = HOME + "/music/favorite/add.do";
        public static String MUSIC_Collection_Remove = HOME + "/music/favorite/remove.do";
        public static String MUSIC_ALL = HOME + "/music/all.do";
        public static String MUSIC_METADATA = HOME + "/music/find/file.do";
        public static String MUSIC_IMAGE = HOME + "/music/web/image.do";
        public static String MUSIC_PLAY = HOME + "/music/play.do";
        public static String MUSIC_RANDOM = HOME + "/music/random.do";


    }

    private static final String TAG = NetworkTool.class.getName();
    private static NetworkTool network;
    public static String downloadPath = AppData.dir + AppData.download_dir + File.separator;

    private NetworkTool() {
        //HOME = "http://192.168.31.92:8000/nas";
        if (StringUtil.isEmpty(HOME)) {
            ping("http://192.168.31.88:8000/public/version.do", new NetworkInterface() {
                @Override
                public void httpGetData(Object data, int state) {
                    HOME = "http://192.168.31.88:8000/nas";
                    AppTools.toast("检测到局域网在线,使用局域网模式");
                }

                @Override
                public void httpError(Exception e) {
                    System.out.println("局域网不在线，走互联网");
                    httpGet("http://tools.yutou233.cn/nas/music/getlocalhost.do?token=" + HTTP_KEY, new JSONObject(), new NetworkInterface() {
                        @Override
                        public void httpGetData(Object data, int state) {
                            try {
                                JSONObject json = JSONObject.parseObject(data.toString());
                                if (json.getInteger("code") == 0) {
                                    HOME = json.getString("data") + ":8000/nas";
                                }
                            } catch (JSONException e) {
                                e.printStackTrace();
                            }
                        }

                        @Override
                        public void httpError(Exception e) {

                        }
                    });
                }
            });

        }
    }

    public static NetworkTool init() {
        if (network == null) {
            network = new NetworkTool();
        }
        return network;
    }

    public void httpGet(String url, JSONObject body, NetworkInterface networkInterface) {
        httpPost(url, body, networkInterface);
    }

    private void ping(String url, NetworkInterface networkInterface) {
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    HttpURLConnection connection = (HttpURLConnection) new URL(url).openConnection();
                    connection.setConnectTimeout(50);
                    connection.setReadTimeout(50);
                    connection.connect();
                    System.out.println(connection.getResponseCode());
                    networkInterface.httpGetData(null, 0);
                    connection.disconnect();
                } catch (Exception e) {
                    networkInterface.httpError(e);
                }
            }
        }).start();
    }

    @Deprecated
    public void httpGet_old(final String url, final JSONObject body, final NetworkInterface networkInterface) {
        if (!url.startsWith("http:") && !StringUtil.isEmpty(HOME)) {
            httpGet(HOME + url, body, networkInterface);
            return;
        }
        if (StringUtil.isEmpty(HOME) && !url.contains("getlocalhost.do")) {
            AppData.handler.postDelayed(new Runnable() {
                @Override
                public void run() {
                    NetworkTool.init().httpGet(url, body, networkInterface);
                }
            }, 300);
            return;
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    System.out.println(url + "?" + toGetSplice(body));
                    HttpURLConnection connection = (HttpURLConnection) new URL(url + "?" + toGetSplice(body)).openConnection();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                    connection.connect();
                    if (connection.getResponseCode() != 200) {
                        networkInterface.httpError(new RuntimeException("http code to :" + connection.getResponseCode()));
                        return;
                    }
                    String tmp;
                    StringBuilder str = new StringBuilder();
                    while ((tmp = reader.readLine()) != null) {
                        str.append(tmp);
                    }
                    reader.close();
                    AppData.handler.post(new Runnable() {
                        @Override
                        public void run() {
                            if (networkInterface != null) {
                                try {
                                    networkInterface.httpGetData(str.toString(), connection.getResponseCode());
                                } catch (IOException e) {
                                    e.printStackTrace();
                                }
                            }

                        }
                    });
                    //Log.i(TAG + "[" + url + "]", "body:" + str + " (" + connection.getResponseCode() + ")");
                } catch (Exception e) {
                    e.printStackTrace();
                    AppData.handler.post(new Runnable() {
                        @Override
                        public void run() {
                            if (networkInterface != null)
                                networkInterface.httpError(e);
                        }
                    });
                    Log.e(TAG, url + " body =" + body.toJSONString());
                }
            }
        }).start();

    }

    private final Map<JSONObject, Integer> map = Collections.synchronizedMap(new HashMap<JSONObject, Integer>());

    public void httpPost(final String url, final JSONObject body, final NetworkInterface networkInterface) {
        if (!url.startsWith("http:") && !StringUtil.isEmpty(HOME)) {
            httpPost(HOME + url, body, networkInterface);
            return;
        }
        if (StringUtil.isEmpty(HOME) && !url.contains("getlocalhost.do")) {
            AppData.handler.postDelayed(new Runnable() {
                @Override
                public void run() {
                    NetworkTool.init().httpPost(url, body, networkInterface);
                }
            }, 300);
            return;
        }
        new Thread(new Runnable() {

            @Override
            public void run() {
                String tmp;
                StringBuilder str = new StringBuilder();
                try {
                    HttpURLConnection connection = (HttpURLConnection) new URL(url).openConnection();
                    connection.setRequestMethod("POST");
                    connection.setDoOutput(true);
                    connection.setDoInput(true);
                    connection.setConnectTimeout(5 * 1000);
                    connection.setReadTimeout(10 * 1000);
                    //connection.addRequestProperty("Connection", "keep-alive");
                    //connection.addRequestProperty("User-Agent", getExtUa());
                    connection.addRequestProperty("content-type", "application/json");
                    connection.addRequestProperty("charset", "UTF-8");
                    OutputStream outputStream = connection.getOutputStream();

                    outputStream.write(body.toJSONString().getBytes());
                    outputStream.flush();
                    outputStream.close();
                    System.out.println(connection.getResponseCode());
                    BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
                    while ((tmp = reader.readLine()) != null) {
                        str.append(tmp);
                    }
                    Log.i(TAG, "[域名]" + url + " = [body]" + body + " -> [接收] " + str);
                    final String finalStr = str.toString();

                    //   Log.i(TAG + "[" + url + "?" + toGetSplice(body) + "]", "body:" + str + " (" + connection.getResponseCode() + ")");
                    map.remove(body);
                    AppData.handler.post(new Runnable() {
                        @Override
                        public void run() {
                            if (networkInterface != null) {
                                try {
                                    networkInterface.httpGetData(str.toString(), connection.getResponseCode());
                                } catch (IOException e) {
                                    e.printStackTrace();
                                }
                            }

                        }
                    });
                    connection.disconnect();
                    reader.close();
                } catch (SocketTimeoutException e) {
                    synchronized (NetworkTool.this) {

                        if (!map.containsKey(body)) {
                            map.put(body, 0);
                        }
                        if (map.get(body) != null && map.get(body) == 0) {
                            map.put(body, 1);
                            httpPost(url, body, networkInterface);
                            return;
                        }
                        if (networkInterface != null)
                            networkInterface.httpError(e);
                    }

                } catch (ConnectException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                    if (networkInterface != null)
                        networkInterface.httpError(e);
                } catch (Exception e) {
                    e.printStackTrace();
                    networkInterface.httpError(e);
                } finally {
                    Log.e(TAG, url + "\n传参:" + body.toString() + "\n接收：" + str);
                }
            }
        }).start();

    }

    private String getExtUa() {
        return "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/83.0.4103.97 Safari/537.36";
    }

    public static String toGetSplice(JSONObject json) {
        try {
            json.put("token", NetworkAPI.HTTP_KEY);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        StringBuilder string = new StringBuilder();
        Set<String> keys = json.keySet();
        for (String key : keys) {
            try {
                string.append("&").append(key).append("=").append(URLEncoder.encode(json.getString(key), "UTF-8"));
            } catch (Exception e) {
                e.printStackTrace();
                try {
                    string.append("&").append(URLEncoder.encode(key, "UTF-8")).append("=");
                    //    string += "&" + key + "=";
                } catch (Exception e1) {
                    string.append("&").append(key).append("=");
                }
            }
        }

        string = new StringBuilder(string.substring(1, string.length()).replaceAll(" ", ""));
        return string.toString();
    }

    public void download(final String url, final String saveName) {
        download(url, new JSONObject(), saveName, "GET", null);
    }

    private final List<String> downloadImageList = new ArrayList<>();

    public synchronized void downloadImage(final String url, final JSONObject body, final String saveName, String method, final DownloadInterface downloadInterface) {
        System.out.println(">>>>>>>>>>" + url);
        if (!url.startsWith("http:") && !StringUtil.isEmpty(HOME)) {
            downloadImage(HOME + url, body, saveName, method, downloadInterface);
            return;
        }
        if (downloadImageList.contains(url + "?" + toGetSplice(body))) {
            return;
        } else {
            downloadImageList.add(url + "?" + toGetSplice(body));
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                File jar = null;
                try {
                    File savePath = new File(downloadPath + saveName + "_tmp.tmp");
                    if (!savePath.exists()) {
                        savePath.getParentFile().mkdirs();
                    }
                    Log.i(TAG, "下载文件:" + url + "?" + toGetSplice(body) + " 保存文件:" + saveName);
                    HttpURLConnection connection = (HttpURLConnection) new URL(url + "?" + toGetSplice(body)).openConnection();

                    //   Log.i(TAG,"获取到网络请求："+connection.getResponseCode());
                    if (method.equalsIgnoreCase("post")) {
                        connection.setRequestMethod("POST");
                        connection.setDoOutput(true);
                        connection.setDoInput(true);
                        connection.setConnectTimeout(5 * 1000);
                        connection.setReadTimeout(10 * 1000);
                        // connection.addRequestProperty("content-type", "application/json");
                        connection.addRequestProperty("charset", "UTF-8");
                       /* OutputStream outputStream = connection.getOutputStream();
                        outputStream.write(body.toJSONString().getBytes());
                        outputStream.flush();
                        outputStream.close();*/
                    }

                    InputStream inputStream = connection.getInputStream();
                    jar = new File(downloadPath+File.separator+"image_cache"+File.separator+saveName + "_tmp.tmp");
                    if(!new File(downloadPath+File.separator+"image_cache").exists()){
                        new File(downloadPath+File.separator+"image_cache").mkdirs();
                    }
                    if(!jar.exists()){
                        jar.createNewFile();
                    }
                    Log.i(NetworkTool.class, "临时保存文件:" + jar.getAbsolutePath());
                    OutputStream outputStream = new FileOutputStream(jar);
                    byte[] bytes = new byte[1024];
                    int len;
                    while ((len = inputStream.read(bytes)) > 0) {
                        outputStream.write(bytes, 0, len);
                    }
                    outputStream.close();
                    inputStream.close();
                    File oldJar = new File(downloadPath + saveName);
                    /*if (oldJar.exists()) {
                        oldJar.delete();
                    }*/
                    jar.renameTo(oldJar);
                    Log.i(NetworkTool.class, "实际保存：" + oldJar.getAbsolutePath() + " " + oldJar.getName());
                    Log.toast(MyApplication.application, "下载完成，重启生效");

                    if (downloadInterface != null) {
                        downloadInterface.onDownloadOver(oldJar);
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                    if (downloadInterface != null)
                        downloadInterface.onError(e);
                }
                downloadImageList.remove(url + "?" + toGetSplice(body));
            }
        }).start();
    }

    public void download(final String url, final JSONObject body, final String saveName, String method, final DownloadInterface downloadInterface) {
        System.out.println(">>>>>>>>>>" + url);
        if (!url.startsWith("http:") && !StringUtil.isEmpty(HOME)) {
            download(HOME + url, body, saveName, method, downloadInterface);
            return;
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                File jar = null;
                try {
                    File savePath = new File(downloadPath + saveName + "_tmp.tmp");
                    if (!savePath.exists()) {
                        savePath.getParentFile().mkdirs();
                    }
                    Log.i(TAG, "下载文件:" + url + " 保存文件:" + saveName);
                    HttpURLConnection connection = (HttpURLConnection) new URL(url).openConnection();

                    //   Log.i(TAG,"获取到网络请求："+connection.getResponseCode());
                    if (method.equalsIgnoreCase("post")) {
                        connection.setRequestMethod("POST");
                        connection.setDoOutput(true);
                        connection.setDoInput(true);
                        connection.setConnectTimeout(5 * 1000);
                        connection.setReadTimeout(10 * 1000);
                        connection.addRequestProperty("content-type", "application/json");
                        connection.addRequestProperty("charset", "UTF-8");
                        OutputStream outputStream = connection.getOutputStream();
                        outputStream.write(body.toJSONString().getBytes());
                        outputStream.flush();
                        outputStream.close();
                    }

                    InputStream inputStream = connection.getInputStream();
                    jar = new File(downloadPath + saveName + "_tmp.tmp");
                    jar.createNewFile();
                    Log.i(NetworkTool.class, "临时保存文件:" + jar.getAbsolutePath());
                    OutputStream outputStream = new FileOutputStream(jar);
                    byte[] bytes = new byte[1024];
                    int len;
                    while ((len = inputStream.read(bytes)) > 0) {
                        outputStream.write(bytes, 0, len);
                    }
                    outputStream.close();
                    inputStream.close();
                    File oldJar = new File(downloadPath + saveName);
                    if (oldJar.exists()) {
                        oldJar.delete();
                    }
                    jar.renameTo(oldJar);
                    Log.i(NetworkTool.class, "实际保存：" + oldJar.getAbsolutePath() + " " + oldJar.getName());
                    Log.toast(MyApplication.application, "下载完成，重启生效");

                    if (downloadInterface != null) {
                        downloadInterface.onDownloadOver(oldJar);
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                    if (downloadInterface != null)
                        downloadInterface.onError(e);

                }
            }
        }).start();
    }
}
