package com.yutou.nas_music_player.views;

import android.content.Context;
import android.util.AttributeSet;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.widget.LinearLayout;

import androidx.annotation.Nullable;
import androidx.core.view.GestureDetectorCompat;

public class MyItemLayout extends LinearLayout {
    private GestureDetectorCompat touch;
    private int mTotalLength;

    public MyItemLayout(Context context) {
        super(context);
        initTouch(context);
    }

    public MyItemLayout(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        initTouch(context);
    }

    private void initTouch(Context context) {
        touch = new GestureDetectorCompat(context, new GestureDetector.SimpleOnGestureListener() {

            @Override
            public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
                System.out.println("MyItemLayout.onFling");
                return super.onFling(e1, e2, velocityX, velocityY);
            }

            @Override
            public boolean onDown(MotionEvent e) {
                System.out.println("MyItemLayout.onDown");
                return true;
            }

            @Override
            public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
                System.out.println("MyItemLayout.onScroll");
                MyItemLayout.this.setX(MyItemLayout.this.getX()+e2.getX());
                return super.onScroll(e1, e2, distanceX, distanceY);
            }
            /*  @Override
            public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
                float y = e2.getY() - e1.getY();
                System.out.println("执行动画");
                if (Math.abs(y) < 200) {
                    float x = e2.getX() - e1.getX();
                    ObjectAnimator animator = new ObjectAnimator();
                    animator.setTarget(MyItemLayout.this);
                    animator.setPropertyName("translationX");
                    animator.setDuration(300);
                    if (x < 0) {
                        animator.setFloatValues(-(mTotalLength - getRight()));
                    } else {
                        animator.setFloatValues(0);
                    }
                    animator.start();
                    return true;
                }
                return super.onScroll(e1, e2, distanceX, distanceY);
            }*/
        });
    }

    private final boolean down = false;
    private final boolean up = false;
    private final boolean move = false;

    @Override
    public boolean onTouchEvent(MotionEvent ev) {
        boolean tmp = super.onTouchEvent(ev);
       /* int action = ev.getAction();
        if (action == MotionEvent.ACTION_DOWN) {
            down = true;
            move = false;
            up = false;
        } else if (action == MotionEvent.ACTION_UP) {
            down = false;
            move = false;
            up = true;
        } else if (action == MotionEvent.ACTION_MOVE) {
            down = true;
            move = true;
            up = false;
        }
        System.out.println("action = " + action + " down = " + down + " move = " + move + " up = " + up);
        if (down && !up && !move) {
            return false;
        } else if (down && move && !up) {
            System.out.println("移动啦");
            boolean clickVal = touch.onTouchEvent(ev);
            return true;
        } else if (down && up && !move) {
            return false;
        }
        AppTools.toast(tmp+"");*/
        tmp=true;
        if (ev.getAction() == MotionEvent.ACTION_MOVE) {
            System.out.println("进触摸");
            boolean clickVal = touch.onTouchEvent(ev);
            return clickVal;
        }
        return tmp;
    }


    @Override
    protected void onLayout(boolean changed, int _left, int top, int _right, int bottom) {
        //right+=300;
        super.onLayout(changed, _left, top, _right, bottom);
    }

    @Override
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec);

        for (int i = 0; i < getChildCount(); i++) {
            mTotalLength += getChildAt(i).getWidth();
        }
        System.out.println("mTotalLength = " + mTotalLength);
    }

}
